//
//  WTDDocument.h
//  What ToDo
//
//  Created by Devin Coughlin on 9/1/07.
//  Copyright 2007 Objective Satisfaction. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#pragma GCC visibility push(default)

extern NSString *WTDDesignatedInboxUUIDDocumentProperty;

#pragma GCC visibility pop



@interface WTDDocument : NSObject {
	NSString *_documentPath;
	
	NSPersistentStoreCoordinator *_dataStoreCoordinator;	
	NSManagedObjectContext *_dataObjectContext;
	
	NSPersistentStoreCoordinator *_presentationStoreCoordinator;	
	NSManagedObjectContext *_presentationObjectContext;
	
	NSMutableDictionary *_documentProperties;
	
	BOOL _isFirstRun;
}

//At some point we will add a read-only parameter
- (id)initWithDocumentPath:(NSString *)path;

- (id)initWithTemporaryDocument;

- (NSString *)documentPath;


- (id)documentPropertyForKey:(NSString *)key;
- (void)setDocumentProperty:(id)property forKey:(NSString *)key;

- (NSManagedObjectContext *)dataObjectContext;
- (NSManagedObjectContext *)presentationObjectContext;


- (BOOL) hasChanges;
- (BOOL) commitEditing;



- (NSError *)save;

- (BOOL) isFirstRun;

- (void)disableUndoRegistration;
- (void)enableUndoRegistration;

+ (NSString *)dataManagedObjectModelName;
+ (NSString *)presentationManagedObjectModelName;


@end
